/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _dmsa_o_H_
#define _dmsa_o_H_
#define dmsa_o_REC_LEN 82


struct dmsa_o
{ 
	INT	DO16;
	INT	DOM3;
	INT	DOM4;
	CHAR	DOM5[74];
}; /* End Struct */

typedef struct dmsa_o dmsa_o ;


int print_dmsa_o (dmsa_o* entry, int decode) ;
int print_dmsa_o_cols (dmsa_o* entry, int decode) ;
int print_dmsa_o_header () ;
FILE* jump_dmsa_o (long recNum) ; 
 

#define dmsa_o_entries 118 

dmsa_o* find_dmsa_o (INT* key); 
int load_dmsa_o (char* ifile, dmsa_o* index) ;
int getnext_dmsa_o (FILE* fp, dmsa_o* entry); 

#define array_dmsa_o_size 5
struct array_dmsa_o
{
   int no_entries;
   dmsa_o *data;
};
typedef struct array_dmsa_o array_dmsa_o; 
int print_array_dmsa_o (array_dmsa_o* array, int decode);
int print_array_dmsa_o_cols (array_dmsa_o* array, int decode);

dmsa_o* search_dmsa_o (INT* key, array_dmsa_o* array) ;
#endif /* _dmsa_o_H_ */
