/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hd_notes_H_
#define _hd_notes_H_
#define hd_notes_REC_LEN 99

#include "ihdnotes.h" 

struct hd_notes
{ 
	INT	DN1;
	CHAR	DN2[2];
	CHAR	DN3[2];
	INT	DN4;
	INT	DN5;
	CHAR	DN6[82];
}; /* End Struct */

typedef struct hd_notes hd_notes ;


int print_hd_notes (hd_notes* entry, int decode) ;
int print_hd_notes_cols (hd_notes* entry, int decode) ;
int print_hd_notes_header () ;
FILE* jump_hd_notes (long recNum) ; 
 
int read_hd_notes (FILE* fp,hd_notes* entry) ; 

#define array_hd_notes_size 15
struct array_hd_notes
{
   int no_entries;
   hd_notes data[array_hd_notes_size];
};
typedef struct array_hd_notes array_hd_notes; 
int read_array_hd_notes (int no_entries, array_hd_notes* array);
int print_array_hd_notes (array_hd_notes* array, int decode);
int print_array_hd_notes_cols (array_hd_notes* array, int decode);

FILE* search_hd_notes (INT* key, array_hd_notes* array) ;
#endif /* _hd_notes_H_ */
