/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hepetran_H_
#define _hepetran_H_
#define hepetran_REC_LEN 46

#include "hip_ep_c.h" 

struct hepetran
{ 
	FLOAT	HTE1;
	FLOAT	HTE2;
	INT	HTE3;
	INT	HTE4;
	INT	HTE5;
	FLOAT	HTE6;
	FLOAT	HTE7;
	INT	HTE8;
	array_hip_ep_c	COINCEDENCE;
}; /* End Struct */

typedef struct hepetran hepetran ;


int print_hepetran (hepetran* entry, int decode) ;
int print_hepetran_cols (hepetran* entry, int decode) ;
int print_hepetran_header () ;
FILE* jump_hepetran (long recNum) ; 
 
int read_hepetran (FILE* fp,hepetran* entry, INT* offset) ; 

#define array_hepetran_size 400
struct array_hepetran
{
   int no_entries;
   hepetran data[array_hepetran_size];
};
typedef struct array_hepetran array_hepetran; 
int read_array_hepetran (FILE* fp,int no_entries, array_hepetran* array, INT* offset);
int print_array_hepetran (array_hepetran* array, int decode);
int print_array_hepetran_cols (array_hepetran* array, int decode);

#endif /* _hepetran_H_ */
