/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hip_dm_c_H_
#define _hip_dm_c_H_
#define hip_dm_c_REC_LEN 240

#include "ihipdmc.h" 
#include "hipdmcom.h" 
#include "hipdmcor.h" 
#include "ihpnotes.h" 
#include "ihdnotes.h" 
#include "ihgnotes.h" 
#include "hg_notes.h" 
#include "hd_notes.h" 
#include "hp_notes.h" 

struct hip_dm_c
{ 
	array_hipdmcom	COMPONENTS;
	array_hipdmcor	CORRELATIONS;
}; /* End Struct */

typedef struct hip_dm_c hip_dm_c ;


int print_hip_dm_c (hip_dm_c* entry, int decode) ;
int print_hip_dm_c_cols (hip_dm_c* entry, int decode) ;
int print_hip_dm_c_header () ;
FILE* jump_hip_dm_c (long recNum) ; 
 

#define array_hip_dm_c_size 2
struct array_hip_dm_c
{
   int no_entries;
   hip_dm_c data[array_hip_dm_c_size];
};
typedef struct array_hip_dm_c array_hip_dm_c; 
int read_array_hip_dm_c (int no_entries, array_hip_dm_c* array);
int print_array_hip_dm_c (array_hip_dm_c* array, int decode);
int print_array_hip_dm_c_cols (array_hip_dm_c* array, int decode);

FILE* search_hip_dm_c (ccdm* key, array_hip_dm_c* array) ;
#endif /* _hip_dm_c_H_ */
