/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hip_dm_g_H_
#define _hip_dm_g_H_
#define hip_dm_g_REC_LEN 197

#include "ihipdm.h" 
#include "hg_notes.h" 
#include "hd_notes.h" 
#include "hp_notes.h" 
#include "ihpnotes.h" 
#include "ihdnotes.h" 
#include "ihgnotes.h" 

struct hip_dm_g
{ 
	INT	DG1;
	FLOAT	DG2;
	FLOAT	DG3;
	FLOAT	DG4;
	FLOAT	DG5;
	FLOAT	DG6;
	FLOAT	DG7;
	FLOAT	DG8;
	FLOAT	DG9;
	FLOAT	DG10;
	FLOAT	DG11;
	CHAR	DG12[2];
	INT	DGM1;
	NONLINEAR	DGM2;
	array_hg_notes	HGNOTES;
	array_hd_notes	HDNOTES;
	array_hp_notes	HPNOTES;
}; /* End Struct */

typedef struct hip_dm_g hip_dm_g ;


int print_hip_dm_g (hip_dm_g* entry, int decode) ;
int print_hip_dm_g_cols (hip_dm_g* entry, int decode) ;
int print_hip_dm_g_header () ;
FILE* jump_hip_dm_g (long recNum) ; 
 
int read_hip_dm_g (FILE* fp,hip_dm_g* entry) ; 
FILE* search_hip_dm_g (INT* key, hip_dm_g* arecord) ;
#endif /* _hip_dm_g_H_ */
