/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hipdmcor_H_
#define _hipdmcor_H_
#define hipdmcor_REC_LEN 240


struct hipdmcor
{ 
	CHAR	DC1[11];
	INT	DC2;
	CHAR	DC3[2];
	CHAR	DC4[2];
	CHAR	DC5[2];
	CHAR	DC6[2];
	INT	DCM1;
	INT	DCM2;
	INT	DCM3;
	INT	DCM4;
	CHAR	DCM5[5];
	INT	DCM6;
	NONLINEAR	DCM9;
}; /* End Struct */

typedef struct hipdmcor hipdmcor ;


int print_hipdmcor (hipdmcor* entry, int decode) ;
int print_hipdmcor_cols (hipdmcor* entry, int decode) ;
int print_hipdmcor_header () ;
FILE* jump_hipdmcor (long recNum) ; 
 
int read_hipdmcor (FILE* fp,hipdmcor* entry) ; 

#define array_hipdmcor_size 10
struct array_hipdmcor
{
   int no_entries;
   hipdmcor data[array_hipdmcor_size];
};
typedef struct array_hipdmcor array_hipdmcor; 
int read_array_hipdmcor (FILE* fp,int no_entries, array_hipdmcor* array);
int print_array_hipdmcor (array_hipdmcor* array, int decode);
int print_array_hipdmcor_cols (array_hipdmcor* array, int decode);

#endif /* _hipdmcor_H_ */
