/* Index access routines */ 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "utils.h"

#include "ihpauth.h" 

int load_idx_hp_auth (char* ifile,idx_hp_auth* index) 
{
/* Routine to load an index from a file. The structure for the index must
 * already exist as must the file of course
 */
   idx_hp_auth idx;
   FILE *fp;
   int i;

   if ( (fp=fopen(ifile,"r"))==NULL)
   {
	fprintf(stderr,"load_idx_hp_auth unable to open %s \n",ifile);
	return (-1);
   }
   if (index == NULL) 
   {
      fprintf (stderr,"load_idx_hp_auth NULL pointer for index\n");
      return (-1);
   }
   /*printf("Loading index idx_hp_auth from %s.. ",ifile);*/
   for (i=0;i<idx_hp_auth_entries;i++)
   {
	if ( (getnext_idx_hp_auth (fp,&index[i])) != 0)
   	{
	   fprintf(stderr,"load_idx_hp_auth problem with entry %d \n",i);
	   break;
	}
   /*     if  ( (i % 5000) == 0) printf("#");*/
   }
   if ( i < idx_hp_auth_entries) 
   {
	fprintf(stderr,"Premature end of index file \n");
   	return -1;
   }
   /* printf(" done \n"); */
   return 0;
} /* End of load_idx_hp_auth*/

int getnext_idx_hp_auth (FILE* fp, idx_hp_auth* entry)
{
   char buffer[idx_hp_auth_REC_LEN + 2];
   if (fgets((char *)&buffer,idx_hp_auth_REC_LEN+1,fp))
   { 
	char delimiter[3]="|\r\0";
	char *token=strtok((char *)&buffer,(char *)&delimiter); 
	strAsINT(token,&entry->HIPID);
	token=strtok(NULL,delimiter);
	strAsINT(token,&entry->RECNUM);
   return 0;
   }
   else
        return -1;
} /* End of getnext_idx_hp_auth */

idx_hp_auth* find_idx_hp_auth (INT* key)
{
   static int init=0;
   static idx_hp_auth index[idx_hp_auth_entries];
   int mid,lpos,rpos,found;
   if (init == 0)
   {
        if (load_idx_hp_auth("../notes/hp_auth.idx",(idx_hp_auth*)&index) !=0)
             return NULL;
        init=1;
   }

   /*  Binary search */ 
   rpos = idx_hp_auth_entries; 
   lpos = 0;
   if (rpos > idx_hp_auth_entries) rpos = idx_hp_auth_entries;
   found = 0;
   while (!found && !(lpos==mid && rpos==mid || lpos > rpos))
   {
	mid =  (rpos + lpos) /2;
        found = index[mid].HIPID.value == key->value;
     	if (key->value > index[mid].HIPID.value )
	   lpos = mid+1;
	else
	   if (key->value < index[mid].HIPID.value)
	      rpos = mid;
	/*printf (" %d,%d Betweeen %d,%d and %d,%d Key = %d\n",mid,index[mid].HIPID.value,lpos,index[lpos].HIPID.value,rpos,index[rpos].HIPID.value,key->value);*/
   }
   if (found)
   {
	/*Go back to first entry for this ref*/
	while (key->value == index[mid].HIPID.value)
	   mid--;
	return &index[mid+1]; /* because we are now at the one before */
   } 
   else
   {
      return NULL;
   }
   
} /* End of find_idx_hp_auth */


